stages:
  - publish

variables:
  GIT_STRATEGY: clone

publish-tauri:
  stage: publish
  parallel:
    matrix:
      - PLATFORM: ['macos', 'ubuntu', 'windows']
  script:
    - |
      if [[ "$PLATFORM" == "macos" ]]; then
        bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"
        eval "$(/home/linuxbrew/.linuxbrew/bin/brew shellenv)"
        brew install nvm
        \. /home/linuxbrew/.linuxbrew/opt/nvm/nvm.sh
        nvm install --lts
      elif [[ "$PLATFORM" == "ubuntu" ]]; then
        apt-get update
        apt-get install -y libwebkit2gtk-4.0-dev libwebkit2gtk-4.1-dev libappindicator3-dev librsvg2-dev patchelf;
        curl -o- https://raw.githubusercontent.com/nvm-sh/nvm/v0.39.1/install.sh | bash
        source /root/.nvm/nvm.sh
        nvm install --lts
      elif [[ "$PLATFORM" == "windows" ]]; then
        apt-get update
        apt-get install -y libwebkit2gtk-4.0-dev libwebkit2gtk-4.1-dev libappindicator3-dev librsvg2-dev patchelf;
        apt-get install -y nsis lld llvm
        curl -o- https://raw.githubusercontent.com/nvm-sh/nvm/v0.39.1/install.sh | bash
        source ~/.nvm/nvm.sh
        nvm install --lts
      fi
    - npm i -g yarn
    - yarn install
    - |
      if [[ "$PLATFORM" == "macos" ]]; then
        rustup target add aarch64-apple-darwin x86_64-apple-darwin &&
        yarn build --target aarch64-apple-darwin
        yarn build --target x86_64-apple-darwin
      elif [[ "$PLATFORM" == "ubuntu" ]]; then
        yarn build --target x86_64-unknown-linux-gnu
      elif [[ "$PLATFORM" == "windows" ]]; then
        curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh
        rustup target add x86_64-pc-windows-msvc
        cargo install cargo-xwin
        yarn build --runner cargo-xwin --target x86_64-pc-windows-msvc
      fi
  only:
    - release

cache:
  paths:
    - node_modules/
    - target/
